javax.net.ssl

## Class ExtendedSSLSession

- java.lang.Object
- - javax.net.ssl.ExtendedSSLSession

- All Implemented Interfaces:
    SSLSession

      public abstract class ExtendedSSLSession
      extends Object
      implements SSLSession

  Extends the `SSLSession` interface to support additional session attributes.
  Since:
    1.7

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtendedSSLSession()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract String[]` | `getLocalSupportedSignatureAlgorithms()` Obtains an array of supported signature algorithms that the local side is willing to use.
    `abstract String[]` | `getPeerSupportedSignatureAlgorithms()` Obtains an array of supported signature algorithms that the peer is able to use.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.net.ssl.SSLSession

      `getApplicationBufferSize, getCipherSuite, getCreationTime, getId, getLastAccessedTime, getLocalCertificates, getLocalPrincipal, getPacketBufferSize, getPeerCertificateChain, getPeerCertificates, getPeerHost, getPeerPort, getPeerPrincipal, getProtocol, getSessionContext, getValue, getValueNames, invalidate, isValid, putValue, removeValue`

- - ### Constructor Detail

    - #### ExtendedSSLSession

          public ExtendedSSLSession()

  - ### Method Detail

    - #### getLocalSupportedSignatureAlgorithms

          public abstract String[] getLocalSupportedSignatureAlgorithms()

      Obtains an array of supported signature algorithms that the local side is willing to use.

      Note: this method is used to indicate to the peer which signature algorithms may be used for digital signatures in TLS 1.2. It is not meaningful for TLS versions prior to 1.2.

      The signature algorithm name must be a standard Java Security name (such as "SHA1withRSA", "SHA256withECDSA", and so on). See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

      Note: the local supported signature algorithms should conform to the algorithm constraints specified by `getAlgorithmConstraints()` method in `SSLParameters`.

      Returns:
        An array of supported signature algorithms, in descending order of preference. The return value is an empty array if no signature algorithm is supported.
      See Also:
        `SSLParameters.getAlgorithmConstraints()`

    - #### getPeerSupportedSignatureAlgorithms

          public abstract String[] getPeerSupportedSignatureAlgorithms()

      Obtains an array of supported signature algorithms that the peer is able to use.

      Note: this method is used to indicate to the local side which signature algorithms may be used for digital signatures in TLS 1.2. It is not meaningful for TLS versions prior to 1.2.

      The signature algorithm name must be a standard Java Security name (such as "SHA1withRSA", "SHA256withECDSA", and so on). See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

      Returns:
        An array of supported signature algorithms, in descending order of preference. The return value is an empty array if the peer has not sent the supported signature algorithms.
      See Also:
        `X509KeyManager`, `X509ExtendedKeyManager`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved.